Option Explicit On
Imports System.Text.RegularExpressions
Imports system
Imports System.IO
Module ModuloEDI
    Public VD4905Message As Array
    Dim lista As ArrayList
    Structure MyStructure
        Public Data As Date
        Public Peca As String
        Public quantidade As Integer
    End Structure
    Public Fitem As MyStructure
    Public VD4905Lines As Integer
    Public t As Integer

    Public Sub LoadTextFile()
        Dim sourceFile As String = M_51.dir_all
        If File.Exists(sourceFile) Then
            VD4905Message = File.ReadAllLines(sourceFile)
            VD4905Lines = VD4905Message.GetUpperBound(t)
        End If
        ciclo4905()
    End Sub
    Private Sub Pc511(ByVal str511 As String)
        M_551.X514 = 0
        Dim versao, fornecedor, cliente, data_transmit, data_inicio As String
        Dim nr_transmit_novo, nr_transmit_antigo As Long
        cliente = str511.Substring(5, 9).Trim
        M_51.cliente = cliente
        versao = str511.Substring(3, 2).Trim
        fornecedor = str511.Substring(14, 9).Trim
        M_51.fornecedor = fornecedor
        nr_transmit_antigo = CLng(str511.Substring(23, 5).Trim)
        M_51.nrtransold = nr_transmit_antigo
        nr_transmit_novo = CLng(str511.Substring(28, 5).Trim)
        M_51.nrtransnew = nr_transmit_novo
        data_transmit = "20" & (str511.Substring(33, 6)).Trim
        M_51.datatrans = CDate(data_transmit)
        If IsNumeric(str511.Substring(39, 6)) = False Then
            data_inicio = str511.Substring(39, 6).Trim
        Else
            data_inicio = "20" & str511.Substring(39, 2).Trim & "/" & str511.Substring(41, 2).Trim & "/" & str511.Substring(43, 2).Trim
        End If
        '***************************************** Making File CSV *********************************
        M_551.X = My.Settings.SendTo & M_51.supplier & "4905" & Mid(My.Forms.Form1.TextBox2.Text, Len(M_51.supplier) + 6) & ".csv"
        If File.Exists(M_551.X) Then
            MsgBox("File Already exists in the directory. Please remove or rename it.", MsgBoxStyle.OkOnly)
            End
        Else
            Dim fs As New FileStream(M_551.X, FileMode.OpenOrCreate, FileAccess.ReadWrite, FileShare.ReadWrite)
            fs.Close()
        End If
        '************************************************** End ******************************************
        '********************************************** Save Line 511 ***************************************
        M_551.i = M_551.i + 10000
        Dim newline As IO.StreamWriter
        newline = New IO.StreamWriter(M_551.X, True)
        newline.WriteLine(M_51.supplier & " RELEASE" & ";" & "" & ";" & "Client:" & ";" & cliente & ";" & "Supplier:" & ";" & fornecedor)
        newline.WriteLine("" & ";" & "" & ";" & "Old Transmission:" & ";" & nr_transmit_antigo & ";" & "New Transmission:" & ";" & nr_transmit_novo)
        newline.WriteLine("" & ";" & "" & ";" & "Transmission Date:" & ";" & Mid(data_transmit, 1, 4) & "/" & Mid(data_transmit, 5, 2) & "/" & Mid(data_transmit, 7, 2) & ";" & "Start Date:" & ";" & data_inicio)
        newline.Close()
        '************************************************** End ******************************************
    End Sub
    Private Sub Pc512(ByVal str512 As String)
        M_551.X514 = 0
        Dim versao, cod_fabrica_cliente, data_entrega_CallOff_novo, data_entrega_CallOff_antigo As String
        Dim nr_entrega_CallOff_novo, nr_entrega_CallOff_antigo As String 'long
        Dim cod_artigo_fornecedor, nr_ordem, local_descarga, cliente_clerck_ID As String
        Dim unidade_medida As String ' ST = piece of; SA = Set; M = meters of; M2 = square meters of; M3 = cubic meters of; L =  litre of; T = ton of; KG = kilograms
        Dim frequencia_entrega As String 'L = "in accordance with calloff date"
        Dim REL_produtor As String
        Dim REL_material As String
        Dim cod_requerimento As String ' S = series; E = spare parts
        Dim chave As String
        Dim local_entrega_stock As String
        versao = str512.Substring(3, 2).Trim
        cod_fabrica_cliente = str512.Substring(5, 3).Trim
        nr_entrega_CallOff_novo = CStr(str512.Substring(8, 9).Trim)
        data_entrega_CallOff_novo = "20" & (str512.Substring(17, 2)).Trim & "/" & (str512.Substring(19, 2)).Trim & "/" & (str512.Substring(21, 2)).Trim
        nr_entrega_CallOff_antigo = CStr(str512.Substring(23, 9).Trim)
        data_entrega_CallOff_antigo = "20" & (str512.Substring(32, 2)).Trim & "/" & (str512.Substring(34, 2)).Trim & "/" & (str512.Substring(36, 2)).Trim
        Fitem.Peca = str512.Substring(38, 22).Trim
        cod_artigo_fornecedor = str512.Substring(60, 22).Trim
        nr_ordem = str512.Substring(82, 12).Trim
        local_descarga = str512.Substring(94, 5).Trim
        cliente_clerck_ID = str512.Substring(99, 4).Trim
        unidade_medida = str512.Substring(103, 2).Trim
        Select Case unidade_medida
            Case "ST"
                unidade_medida = "piece of"
            Case "SA"
                unidade_medida = "set"
            Case "M"
                unidade_medida = "meters of"
            Case "M2"
                unidade_medida = "square meters of"
            Case "M3"
                unidade_medida = "cubic meters of"
            Case "L"
                unidade_medida = "litre of"
            Case "T"
                unidade_medida = "ton of"
            Case "KG"
                unidade_medida = "kilograms"
        End Select
        Select Case str512.Substring(105, 1).Trim
            Case Is = "L"
                frequencia_entrega = "in accordance with calloff date"
            Case Else
                frequencia_entrega = str512.Substring(105, 1).Trim
        End Select
        REL_produtor = str512.Substring(106, 1).Trim
        REL_material = str512.Substring(107, 1).Trim
        cod_requerimento = str512.Substring(108, 1).Trim
        Select Case cod_requerimento
            Case "S"
                cod_requerimento = "series"
            Case "E"
                cod_requerimento = "spare parts"
        End Select
        chave = str512.Substring(109, 7).Trim
        local_entrega_stock = str512.Substring(116, 7).Trim
        ''*********************** Save Line 512 ****************************
        Dim newline As IO.StreamWriter
        newline = New IO.StreamWriter(M_551.X, True)
        newline.WriteLine()
        newline.WriteLine("PN" & ";" & "Client Factory" & ";" & "New CallOff Number" & ";" & "New CallOff Date" & ";" & "Old CallOff Number" & ";" & "Old CallOff Date" & ";" & "Nr" & ";" & "Delivery Place" & ";" & "Client Clerck ID" & ";" & "Measure Unit" & ";" & "Delivery Frequency" & ";" & "REL Producer" & ";" & "REL Material" & ";" & "Requirement Code" & ";" & "Key" & ";" & "Stock Delivery Place")
        newline.WriteLine(Fitem.Peca & ";" & cod_fabrica_cliente & ";" & nr_entrega_CallOff_novo & ";" & data_entrega_CallOff_novo & ";" & nr_entrega_CallOff_antigo & ";" & data_entrega_CallOff_antigo & ";" & nr_ordem & ";" & local_descarga & ";" & cliente_clerck_ID & ";" & unidade_medida & ";" & frequencia_entrega & ";" & REL_produtor & ";" & REL_material & ";" & cod_requerimento & ";" & chave & ";" & local_entrega_stock)
        newline.Close()
        ''*********************** End ****************************
    End Sub
    Private Sub pc513(ByVal str513 As String)
        Dim versao, a1 As String
        Dim a2 As String
        Dim i As Integer
        Dim j As Integer
        Dim data_ultimo_registo As String
        Dim nr_guia_anterior As String
        Dim data_guia_anterior As String
        Dim ultima_quant_entregue As Long
        Dim recepcao_acumulada As Long
        versao = str513.Substring(3, 2).Trim
        data_ultimo_registo = "20" & (str513.Substring(5, 6)).Trim
        M_513.data_ultimo_registo = data_ultimo_registo
        nr_guia_anterior = str513.Substring(11, 8).Trim
        M_513.nr_guia_anterior = nr_guia_anterior
        If IsNumeric(str513.Substring(19, 6)) = True Then
            data_guia_anterior = "20" & (str513.Substring(19, 2)).Trim & "/" & (str513.Substring(21, 2)).Trim & "/" & (str513.Substring(23, 2)).Trim
        Else
            data_guia_anterior = (str513.Substring(19, 6)).Trim
        End If
        M_513.data_guia_anterior = data_guia_anterior
        ultima_quant_entregue = CLng(CDbl(str513.Substring(25, 12)) / 1000)
        M_513.ultima_quant_entregue = CInt(ultima_quant_entregue)
        recepcao_acumulada = CLng(str513.Substring(37, 10))
        M_513.recepcao_acumulada = CInt(recepcao_acumulada)
        ''*********************** Save Line 513 step 1/2 ****************************
        Dim newline As IO.StreamWriter
        newline = New IO.StreamWriter(M_551.X, True)
        newline.WriteLine("" & ";" & "Last record date:" & ";" & Mid(data_ultimo_registo, 1, 4) & "/" & Mid(data_ultimo_registo, 5, 2) & "/" & Mid(data_ultimo_registo, 7, 2) & ";" & "Old Delivery Note Number:" & ";" & nr_guia_anterior & ";" & "Old Delivery Note Date:" & ";" & data_guia_anterior)
        newline.WriteLine("" & ";" & "Last Received Quantity:" & ";" & ultima_quant_entregue & ";" & "Accumulated reception quantity:" & ";" & recepcao_acumulada)
        newline.WriteLine("Date" & ";" & "Quantity" & ";" & "Accumulated")
        newline.Close()
        ''*********************** End ****************************
        For i = 47 To (str513.Length - 15) Step 15
            Dim S As Integer
            S = S + 1
            If M_551.X514 = 1 Then
                a1 = "20" & (str513.Substring(i, 2)).Trim & "/" & (str513.Substring(i + 2, 2)).Trim & "/" & (str513.Substring(i + 4, 2)).Trim
                a2 = str513.Substring((i + 6), 9).Trim
                For j = i + 15 To (str513.Length - 15) Step 15
                    If str513.Substring(j, 6) = "000000" Or str513.Substring(j, 6).Trim = "" Then
                        Exit For
                    Else
                        a1 = ("y:" & str513.Substring(j, 2) & "w:" & str513.Substring(j + 2, 2) & "-" & str513.Substring(j + 4, 2))
                        a2 = str513.Substring((j + 6), 9).Trim
                        Select Case S
                            Case 1
                                M_551.d1 = a1
                                M_551.q1 = CLng(a2)
                            Case 2
                                M_551.d2 = a1
                                M_551.q2 = CLng(a2)
                            Case 3
                                M_551.d3 = a1
                                M_551.q3 = CLng(a2)
                            Case 4
                                M_551.d4 = a1
                                M_551.q4 = CLng(a2)
                            Case 5
                                M_551.d5 = a1
                                M_551.q5 = CLng(a2)
                        End Select
                    End If
                Next j
                i = j
            Else '1 line
                Select Case str513.Substring(i, 6).Trim
                    Case "000000"
                        Exit For
                    Case "222222"
                        Exit For
                    Case "555555"
                        M_551.X514 = 1
                        a1 = "20" & (str513.Substring(i, 2)).Trim & "/" & (str513.Substring(i + 2, 2)).Trim & "/" & (str513.Substring(i + 4, 2)).Trim
                        a2 = str513.Substring((i + 6), 9).Trim
                        For j = i + 15 To (str513.Length - 15) Step 15
                            If str513.Substring(j, 6) = "000000" Or str513.Substring(j, 6).Trim = "" Then
                                Exit For
                            Else
                                a1 = ("y:" & str513.Substring(j, 2) & "w:" & str513.Substring(j + 2, 2) & "-" & str513.Substring(j + 4, 2))
                                a2 = str513.Substring((j + 6), 9).Trim
                                Select Case S
                                    Case 1
                                        M_551.d1 = a1
                                        M_551.q1 = CLng(a2)
                                    Case 2
                                        M_551.d2 = a1
                                        M_551.q2 = CLng(a2)
                                    Case 3
                                        M_551.d3 = a1
                                        M_551.q3 = CLng(a2)
                                    Case 4
                                        M_551.d4 = a1
                                        M_551.q4 = CLng(a2)
                                    Case 5
                                        M_551.d5 = a1
                                        M_551.q5 = CLng(a2)
                                End Select
                                S = S + 1
                            End If
                        Next j
                        i = j
                    Case "999999"
                        a1 = ("Months Preview:" & str513.Substring(i, 6)).Trim
                        a2 = str513.Substring((i + 6), 9).Trim
                    Case Else
                        a1 = (str513.Substring(i, 6)).Trim
                        If a1 = "333333" Then
                            a1 = "BACKLOG"
                        ElseIf a1 = "444444" Then
                            a1 = "IMEDIATE REQUEST"
                        Else
                            a1 = "20" & (str513.Substring(i, 2)).Trim & "/" & (str513.Substring(i + 2, 2)).Trim & "/" & (str513.Substring(i + 4, 2)).Trim
                        End If
                        a2 = str513.Substring((i + 6), 9).Trim
                        Select Case S
                            Case 1
                                M_551.d1 = a1
                                M_551.q1 = CLng(a2)
                            Case 2
                                M_551.d2 = a1
                                M_551.q2 = CLng(a2)
                            Case 3
                                M_551.d3 = a1
                                M_551.q3 = CLng(a2)
                            Case 4
                                M_551.d4 = a1
                                M_551.q4 = CLng(a2)
                            Case 5
                                M_551.d5 = a1
                                M_551.q5 = CLng(a2)
                        End Select
                End Select
            End If
        Next i
        ''*********************** Save Line 513 step 2/2 ****************************
        newline = New IO.StreamWriter(M_551.X, True)
        M_513.recepcao_acumulada = CInt(M_513.recepcao_acumulada + M_551.q1)
        newline.WriteLine(M_551.d1 & ";" & M_551.q1 & ";" & M_513.recepcao_acumulada)
        M_513.recepcao_acumulada = CInt(M_513.recepcao_acumulada + M_551.q2)
        newline.WriteLine(M_551.d2 & ";" & M_551.q2 & ";" & M_513.recepcao_acumulada)
        M_513.recepcao_acumulada = CInt(M_513.recepcao_acumulada + M_551.q3)
        newline.WriteLine(M_551.d3 & ";" & M_551.q3 & ";" & M_513.recepcao_acumulada)
        M_513.recepcao_acumulada = CInt(M_513.recepcao_acumulada + M_551.q4)
        newline.WriteLine(M_551.d4 & ";" & M_551.q4 & ";" & M_513.recepcao_acumulada)
        M_513.recepcao_acumulada = CInt(M_513.recepcao_acumulada + M_551.q5)
        newline.WriteLine(M_551.d5 & ";" & M_551.q5 & ";" & M_513.recepcao_acumulada)
        newline.Close()
        ''*********************** End ****************************
    End Sub
    Private Sub pc514(ByVal str514 As String)
        Dim versao, a1 As String
        Dim a2 As String
        Dim i As Integer
        Dim j As Integer
        Dim S As Integer = 0
        M_551.d1 = ""
        M_551.q1 = 0
        M_551.d2 = ""
        M_551.q2 = 0
        M_551.d3 = ""
        M_551.q3 = 0
        M_551.d4 = ""
        M_551.q4 = 0
        M_551.d5 = ""
        M_551.q5 = 0
        M_551.d6 = ""
        M_551.q6 = 0
        M_551.d7 = ""
        M_551.q7 = 0
        M_551.d8 = ""
        M_551.q8 = 0
        versao = str514.Substring(3, 2).Trim
        For i = 5 To (str514.Length - 15) Step 15
            S = S + 1
            If S = 9 Then Exit Sub
            Select Case str514.Substring(i, 6).Trim
                Case "000000"
                    M_551.X514 = 0
                    Exit Sub
                Case "222222"
                    M_551.X514 = 0
                    Exit Sub
                Case "555555"
                    M_551.X514 = 1
                    a1 = "20" & (str514.Substring(i, 2)).Trim & "/" & (str514.Substring(i + 2, 2)).Trim & "/" & (str514.Substring(i + 4, 2)).Trim
                    a2 = str514.Substring((i + 6), 9).Trim
                    For j = i + 15 To (str514.Length - 15) Step 15
                        S = S + 1
                        If S = 9 Then Exit Sub
                        If str514.Substring(j, 6) = "000000" Or str514.Substring(j, 6).Trim = "" Then
                            a1 = ""
                            a2 = CStr(0)
                        Else
                            a1 = ("y:" & str514.Substring(j, 2) & "w:" & str514.Substring(j + 2, 2) & "-" & str514.Substring(j + 4, 2))
                            a2 = str514.Substring((j + 6), 9).Trim
                        End If
                        Dim newline As IO.StreamWriter
                        newline = New IO.StreamWriter(M_551.X, True)
                        M_551.i = M_551.i + 1
                        M_513.recepcao_acumulada = CInt(M_513.recepcao_acumulada + CDbl(a2))
                        newline.WriteLine(a1 & ";" & CDbl(a2) & ";" & M_513.recepcao_acumulada)
                        newline.Close()
                    Next j
                Case "999999"
                    M_551.X514 = 0
                    a1 = ("Months Preview:" & str514.Substring(i, 6)).Trim
                    a2 = str514.Substring((i + 6), 9).Trim
                    M_551.d9 = a1
                    M_551.q9 = CLng(a2)
                    Dim newline As IO.StreamWriter
                    newline = New IO.StreamWriter(M_551.X, True)
                    M_513.recepcao_acumulada = CInt(M_513.recepcao_acumulada + CDbl(a2))
                    newline.WriteLine(a1 & ";" & CDbl(a2) & ";" & M_513.recepcao_acumulada)
                    newline.Close()
                Case Else
                    If M_551.X514 = 1 Then
                        S = S - 1
                        If i = 5 Then i = -10
                        For j = i + 15 To (str514.Length - 15) Step 15
                            S = S + 1
                            If S = 9 Then Exit Sub
                            If str514.Substring(j, 6) = "000000" Or str514.Substring(j, 6).Trim = "" Then
                                a1 = ""
                                a2 = CStr(0)
                            Else
                                a1 = ("y:" & str514.Substring(j, 2) & "w:" & str514.Substring(j + 2, 2) & "-" & str514.Substring(j + 4, 2))
                                a2 = str514.Substring((j + 6), 9).Trim
                                Dim newline As IO.StreamWriter
                                newline = New IO.StreamWriter(M_551.X, True)
                                M_551.i = M_551.i + 1
                                M_513.recepcao_acumulada = CInt(M_513.recepcao_acumulada + CDbl(a2))
                                newline.WriteLine(a1 & ";" & CDbl(a2) & ";" & M_513.recepcao_acumulada)
                                newline.Close()
                            End If
                            i = j
                        Next j
                    Else
                        If (str514.Substring(i, 6)).Trim = "" Then Exit Select
                        a1 = "20" & (str514.Substring(i, 2)).Trim & "/" & (str514.Substring(i + 2, 2)).Trim & "/" & (str514.Substring(i + 4, 2)).Trim
                        a2 = str514.Substring((i + 6), 9).Trim
                        Dim newline As IO.StreamWriter
                        newline = New IO.StreamWriter(M_551.X, True)
                        M_513.recepcao_acumulada = CInt(M_513.recepcao_acumulada + CDbl(a2))
                        newline.WriteLine(a1 & ";" & CDbl(a2) & ";" & M_513.recepcao_acumulada)
                        newline.Close()
                    End If
            End Select
        Next i
    End Sub
    Private Sub pc515(ByVal str515 As String)
        M_551.X514 = 0
        Dim versao, local_consumo_stock As String
        Dim ultima_quant_acumulada As Long
        versao = str515.Substring(3, 2).Trim
        local_consumo_stock = str515.Substring(86, 14).Trim
        ultima_quant_acumulada = CLng(str515.Substring(100, 10))
        ''*********************** Save Line 515 ****************************
        Dim newline As IO.StreamWriter
        newline = New IO.StreamWriter(M_551.X, True)
        M_551.i = M_551.i + 1
        newline.WriteLine("Stock Consumption Place:" & ";" & local_consumo_stock & ";" & "Last Accumulated Quantity:" & ";" & ultima_quant_acumulada)
        newline.Close()
        ''*********************** End ****************************
    End Sub
    Private Sub pc517(ByVal str517 As String)
        M_551.X514 = 0
        Dim versao, pack_cod_cliente, pack_cod_fornecedor As String
        Dim capacidade_pack_type As String
        versao = str517.Substring(3, 2).Trim
        pack_cod_cliente = str517.Substring(5, 22).Trim
        pack_cod_fornecedor = str517.Substring(27, 22).Trim
        capacidade_pack_type = str517.Substring(49, 7)
        ''*********************** Save Line 517 ****************************
        Dim newline As IO.StreamWriter
        newline = New IO.StreamWriter(M_551.X, True)
        M_551.i = M_551.i + 1
        newline.WriteLine("Pack Client Code:" & ";" & pack_cod_cliente & ";" & "Pack Supplier Code:" & ";" & pack_cod_fornecedor & ";" & "Pack Type Capacity:" & ";" & capacidade_pack_type)
        newline.Close()
        ''*********************** End ****************************
    End Sub
    Private Sub pc518(ByVal str518 As String)
        M_551.X514 = 0
        Dim versao, instrucao_entrega_text1, instrucao_entrega_text2, instrucao_entrega_text3 As String
        versao = str518.Substring(3, 2).Trim
        instrucao_entrega_text1 = str518.Substring(5, 40)
        instrucao_entrega_text2 = str518.Substring(45, 40)
        instrucao_entrega_text3 = str518.Substring(85, 40)
        ''*********************** Save Line 518 ****************************
        Dim newline As IO.StreamWriter
        newline = New IO.StreamWriter(M_551.X, True)
        M_551.i = M_551.i + 1
        newline.WriteLine("Delivey Instruction 1:" & ";" & instrucao_entrega_text1 & ";" & "Delivey Instruction 2:" & ";" & instrucao_entrega_text2 & ";" & "Delivey Instruction 3:" & ";" & instrucao_entrega_text3)
        newline.Close()
        ''*********************** End ****************************
    End Sub
    Private Sub Pc519(ByVal str519 As String)
        M_551.X514 = 0
        Dim contador511, contador512, contador513, contador514, contador517, contador518, contador519, contador515 As String
        Dim versao As String
        versao = str519.Substring(3, 2).Trim
        contador511 = CStr(str519.Substring(5, 7))  ' nr of type 511
        contador512 = CStr(str519.Substring(12, 7)) ' nr of type 512
        contador513 = CStr(str519.Substring(19, 7)) ' nr of type 513
        contador514 = CStr(str519.Substring(26, 7)) ' nr of type 514
        contador517 = CStr(str519.Substring(33, 7)) ' nr of type 517
        contador518 = CStr(str519.Substring(40, 7)) ' nr of type 518
        contador519 = CStr(str519.Substring(47, 7)) ' nr of type 519
        contador515 = CStr(str519.Substring(54, 7)) ' nr of type 515
        ''*********************** Save Line 519 ****************************
        Dim newline As IO.StreamWriter
        newline = New IO.StreamWriter(M_551.X, True)
        M_551.i = M_551.i + 1
        newline.WriteLine("contador511" & ";" & "contador512" & ";" & "contador513" & ";" & "contador514" & ";" & "contador515" & ";" & "contador517" & ";" & "contador518" & ";" & "contador519")
        newline.WriteLine(contador511 & ";" & contador512 & ";" & contador513 & ";" & contador514 & ";" & contador515 & ";" & contador517 & ";" & contador518 & ";" & contador519)
        newline.Close()
        ''*********************** End ****************************


    End Sub
    Private Sub ciclo4905()
        For t = 0 To VD4905Lines
            Select Case Left(CStr(VD4905Message.GetValue(t)), 3)
                Case CStr(511)
                    Pc511(CStr(VD4905Message.GetValue(t)))
                Case CStr(512)
                    Pc512(CStr(VD4905Message.GetValue(t)))
                Case CStr(513)
                    pc513(CStr(VD4905Message.GetValue(t)))
                    clear513()
                Case CStr(514)
                    clear513()
                    pc514(CStr(VD4905Message.GetValue(t)))
                Case CStr(515)
                    clear513()
                    pc515(CStr(VD4905Message.GetValue(t)))
                Case CStr(517)
                    clear513()
                    pc517(CStr(VD4905Message.GetValue(t)))
                Case CStr(518)
                    clear513()
                    pc518(CStr(VD4905Message.GetValue(t)))
                Case CStr(519)
                    clear513()
                    Pc519(CStr(VD4905Message.GetValue(t)))
            End Select
        Next
    End Sub
    Private Sub clear513()
        M_551.d1 = ""
        M_551.q1 = CLng(0)
        M_551.d2 = ""
        M_551.q2 = CLng(0)
        M_551.d3 = ""
        M_551.q3 = CLng(0)
        M_551.d4 = ""
        M_551.q4 = CLng(0)
        M_551.d5 = ""
        M_551.q5 = CLng(0)
        M_551.d6 = ""
        M_551.q6 = CLng(0)
        M_551.d7 = ""
        M_551.q7 = CLng(0)
        M_551.d8 = ""
        M_551.q8 = CLng(0)
        M_551.d9 = ""
        M_551.q9 = CLng(0)
    End Sub
End Module
